﻿//-------------------------------------------------------------------------------------
// <copyright file="BtsOrchestrationPortCollection.cs" company="Microsoft">
//      Copyright (c) 2003 Microsoft Corporation. All rights reserved.
//      THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
//      EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED 
//      WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// </copyright>
// <summary>
//      BtsOrchestrationPortCollection
// </summary>  
//-------------------------------------------------------------------------------------
namespace Microsoft.Sdc.Tasks.BizTalk2004.Configuration
{
    #region Using directives

    using System;
    using System.Collections;
    using System.Text;

    #endregion

    internal class BtsOrchestrationPortCollection : System.Collections.ReadOnlyCollectionBase
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public BtsOrchestrationPortCollection()
        {
        }

        /// <summary>
        /// Indexer
        /// </summary>
        /// <param name="name">string</param>
        /// <returns>BtsOrchestrationPort</returns>
        public BtsOrchestrationPort this[string name]
        {
            get
            {
                BtsOrchestrationPort item = null;
                foreach (BtsOrchestrationPort currentitem in this.InnerList)
                {
                    if (currentitem.Name == name)
                    {
                        item = currentitem;
                        break;
                    }
                }
                return item;
            }
        }

        /// <summary>
        /// Indexer
        /// </summary>
        /// <param name="index">int</param>
        /// <returns>BtsOrchestrationPort</returns>
        public BtsOrchestrationPort this[int index]
        {
            get
            {
                return (BtsOrchestrationPort)this.InnerList[index];
            }
        }      

        /// <summary>
        /// Clear
        /// </summary>
        public void Clear()
        {
            this.InnerList.Clear();
        }
        
        internal void Add(BtsOrchestrationPort item)
        {
            this.InnerList.Add(item);
        }
    }
}
