//-----------------------------------------------------------------------
// <copyright file="Exists.cs" company="Microsoft">
// Copyright (c) Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY 
// KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
// </copyright>
//-----------------------------------------------------------------------
namespace Microsoft.Sdc.Tasks.BizTalk2006.ReceiveLocation
{
    using BizTalk.ExplorerOM;

    /// <summary>
    /// Checks if ReceiveLocation exists
    /// </summary>
    public class Exists : BizTalk2004.ReceiveLocation.Exists
    {
        private string application;

        /// <summary>
        /// Gets or sets the application.
        /// </summary>
        /// <value>The application.</value>
        public string Application
        {
            get { return this.application; }
            set { this.application = value; }
        }

        /// <summary>
        /// Execute the task
        /// </summary>
        protected override void InternalExecute()
        {
            if (string.IsNullOrEmpty(this.Application))
            {
                base.InternalExecute();
            }
            else
            {
                BtsCatalogExplorer explorer = this.GetBtsCatalogExplorer(this.Server, this.Database);

                Application app = explorer.Applications[this.Application];
                if (app != null)
                {
                    ReceivePort port = app.ReceivePorts[this.ReceivePort];
                    if (port != null)
                    {
                        ReceiveLocation loc = port.ReceiveLocations[this.Name];
                        if (loc == null)
                        {
                            this.ReceiveLocationExists = false;
                        }
                        else
                        {
                            this.ReceiveLocationExists = true;
                        }
                    }
                    else
                    {
                        this.ReceiveLocationExists = false;
                    }
                }
                else
                {
                    this.ReceiveLocationExists = false;
                }
            }
        }
    }
}
