﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.Sdc.Tasks;

namespace Microsoft.Sdc.Tasks.Test
{
    using Microsoft.VisualStudio.TestTools.UnitTesting;
    using System;
    using System.Text;
    using System.Collections.Generic;
    using Microsoft.Sdc.Tasks;
    using Microsoft.Build.Framework;
    /// <summary>
    ///This is a test class for Microsoft.Sdc.Tasks.GetEnvironmentVariable and is intended
    ///to contain all Microsoft.Sdc.Tasks.GetEnvironmentVariable Unit Tests
    ///</summary>
    [TestClass()]
    public class GetEnvironmentVariableTest
    {
        private TestContext testContextInstance;
        
        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get { return this.testContextInstance; }
            set { this.testContextInstance = value; }
        }
       
        /// <summary>
        ///A test for InternalExecute ()
        ///</summary>
        [DeploymentItem("Microsoft.Sdc.Tasks.dll")]
        [TestMethod()]
        public void GetEnvironmentVariableExecuteTest()
        {
            GetEnvironmentVariable task = new GetEnvironmentVariable();
            
            task.Variable = "Path";
            task.Target = EnvironmentVariableTarget.Machine.ToString();

            bool taskReturnValue = task.Execute();

            string bob = task.Target;

            //Test the return value
            Assert.IsTrue(taskReturnValue, "Task returned false");
        }

        /// <summary>
        ///A test for Variable
        ///</summary>
        [TestMethod()]
        public void VariableTest()
        {
            GetEnvironmentVariable target = new GetEnvironmentVariable();

            string val = "bob";

            target.Variable = val;
            
            Assert.AreEqual(val, target.Variable, "Microsoft.Sdc.Tasks.GetEnvironmentVariable.Variable was not set correctly.");
           
        }
    }
}




