/*
<?xml version="1.0" encoding="iso-8859-1"?>
<FileInfo>
  <Author>Andy Reeves</Author>
  <Date />
  <Description />
  <Copyright><![CDATA[
    Copyright  2003 Microsoft Corporation. All rights reserved.
    THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY 
    KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
    PARTICULAR PURPOSE.
    ]]></Copyright>
</FileInfo>
*/

namespace Microsoft.Sdc.Tasks.Configuration.ComponentServices {
    using System.Collections;

    /// <summary>
    /// Summary description for ComponentCollection.
    /// </summary>
    internal class ComponentCollection : CollectionBase {
        Application parentApplication;


        internal ComponentCollection(Application parent) {
            parentApplication = parent;
        }

        internal ComponentCollection(Application parent, ComWrapper collection) {
            parentApplication = parent;
            int j = (int)collection.GetProperty("Count");
            int i = 0;
            while (i < j)
            {
                object objTempApp = collection.GetProperty("item", i) ;
                ComWrapper catalogObject = new ComWrapper(objTempApp);
                List.Add(new Component(catalogObject, collection));
                i = i + 1;
            }
        }

        /*
        public int Add(Component component) {

            //if (directory.Name.Trim().Length == 0) {
            //  throw new ApplicationException("Virtual Directory name must be provided before adding to a collection");
            //}
            //int index = GetIndexFromName(directory.Name);
            //if (index > -1) {
            //  throw new ApplicationException(String.Format(CultureInfo.InvariantCulture, "A VirtualDirectory with the name '{0}' already exists.", directory.Name));
            //}
            //directory.Parent = parentWebSite;
            return List.Add(component);
        }
        */
        public int IndexOf(Component value) {
            return List.IndexOf(value);
        }

        /*
        public void Insert(int index, Component value) {
            //value.Parent = parentWebSite;
            List.Insert(index, value);
        }

        public void Remove(Component value) {
            List.Remove(value);
        }
        */
        /*
        public void CopyTo(ComponentCollection collection, int index) {
            if (collection == null)
                throw new ArgumentNullException("collection");
            if (index < 0)
                throw new ArgumentOutOfRangeException("index", index, "index needs to be greater than 0");
            
            int i = 0;          
            while(i < List.Count) {
                collection[i+index] = (Component)List[i];
                i++;
            }
        }   
        */
        public bool Contains(Component value) {
            return (List.Contains(value));
        }

        public Component this[int index] {
            get {
                return (Component) List[index];
            }
        }
        
        int GetIndexFromName(string name) {
            Component comp;
            for(int i=0; i < List.Count; i++) {
                comp = (Component)List[i];
                if (comp.Name == name) {
                    return i;
                }
            }       
            return -1;
        }       
        
        public Component this[string name] {
            get {
                int index = GetIndexFromName(name);
                if (index == -1) {
                    return null;
                }
                return (Component) List[index];
            }
        }       
    }
}