/*
<?xml version="1.0" encoding="iso-8859-1"?>
<FileInfo>
  <Date />
  <Description />
  <Copyright><![CDATA[
    Copyright  2001 - 2003 Microsoft Corporation. All rights reserved.
    THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY 
    KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
    PARTICULAR PURPOSE.
    ]]></Copyright>
</FileInfo>
*/


namespace Microsoft.Sdc.Tasks.Configuration.Win32Security {
    using System;
    using System.Collections;
    using System.Runtime.InteropServices;
    class OrderAceAccess : IComparer {
        public int Compare(object o1, object o2) {
            AceAccess lhs = (AceAccess)o1;
            AceAccess rhs = (AceAccess)o2;

            if(lhs.IsInherited && !rhs.IsInherited)
                return 1;

            if(!lhs.IsInherited && rhs.IsInherited)
                return -1;

            if(lhs.IsAllowed && !rhs.IsAllowed)
                return 1;

            if(!lhs.IsAllowed && rhs.IsAllowed)
                return -1;

            if(lhs.IsObjectAce && !rhs.IsObjectAce)
                return 1;

            if(!lhs.IsObjectAce && rhs.IsObjectAce)
                return -1;

            return 0;
        }
    }

    /// <summary>
    /// Summary description for Dacl.
    /// </summary>
    internal class Dacl : AclInternal {
        internal Dacl(IntPtr pacl) : base(pacl) {
        }
        public Dacl() : base() {
        }
		
        protected override void PrepareAcesForACL() {
            IComparer comparer = new OrderAceAccess();

            int nCount = this.AceCount;

            int h = 1;
            while(h * 3 + 1 < nCount)
                h = 3 * h + 1;

            while(h > 0) {
                for(int i = h - 1; i < nCount; i++) {
                    Ace pivot = this.GetAce(i);

                    int j;
                    for(j = i; 
                        (j >= h) && (comparer.Compare(this.GetAce(j - h), pivot) > 0); 
                        j -= h) {
                        this.SetAce(j, this.GetAce(j - h));
                    }

                    this.SetAce(j, pivot);
                }

                h /= 3;
            }
        }
        internal void AddAce(AceAccess ace) {
            base.AddAce(ace);
        }
    }
}
