//-----------------------------------------------------------------------
// <copyright file="Login.cs" company="Microsoft">
// Copyright (c) Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY 
// KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
// </copyright>
// <author>Barry Dorrans</author>
// <email>barryd@charteris.com</email>
// <date>2005-07-18</date>
// <summary>Internal stacks used for the login and logout task</summary>
//-----------------------------------------------------------------------

namespace Microsoft.Sdc.Tasks.Security
{
  using System;
  using System.Collections.Generic;
  using System.Text;

  using System.Security.Principal;

  /// <summary>
  /// Internal static stacks used to save the impersonation contexts and process handles between the login and
  /// logout tasks.
  /// </summary>
  internal static class contextStacks
  {
    public static Stack<WindowsImpersonationContext> impersonationContexts = new Stack<WindowsImpersonationContext>();
    public static Stack<IntPtr> processHandles = new Stack<IntPtr>();
  }

}
