//-----------------------------------------------------------------------
// <copyright file="SetEnvironmentVariable.cs" company="Microsoft">
// Copyright (c) Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY 
// KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
// </copyright>
// <author>Andy Reeves</author>
// <email>andyr</email>
// <date>2004-03-25</date>
// <summary></summary>
//-----------------------------------------------------------------------

namespace Microsoft.Sdc.Tasks
{
    using System;
    using System.Xml;
    using System.Globalization;
    using Microsoft.Build.Framework;

    public class SetEnvironmentVariable : TaskBase
    {
        private string value;
        private string variable;
        private EnvironmentVariableTarget target = EnvironmentVariableTarget.Process;

        /// <summary>
        /// Initializes a new instance of the SetEnvironmentVariable class.
        /// </summary>
        public SetEnvironmentVariable()
        {
        }

        /// <summary>
        /// Performs the action of this task.
        /// </summary>
        protected override void InternalExecute()
        {
            Environment.SetEnvironmentVariable(this.variable, this.value, this.target);
        }

        /// <summary>
        /// 
        /// </summary>
        [Required]
        public string Value
        {
            set { this.value = value; }
            get { return this.value; }
        }

        /// <summary>
        /// 
        /// </summary>
        [Required]
        public string Variable
        {
            set { this.variable = value; }
            get { return this.variable; }
        }

        /// <summary>
        /// 
        /// </summary>
        public string Target
        {
            set { this.target = (EnvironmentVariableTarget)Enum.Parse(typeof(EnvironmentVariableTarget), value); }
            get { return this.target.ToString("G"); }
        }
    }
}

