// <copyright file="ModifyActionOptionValue.cs" company="Microsoft">
// Copyright (c) Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY 
// KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
// </copyright>
// <author>Steven Sloggett (Charteris)</author>
// <email>v-stslog</email>
// <date>2004-03-23</date>
// <summary>The action to take when modifying a file.</summary>

namespace Microsoft.Sdc.Tasks.Xml
{
    using System;

    /// <summary>
    /// The action to take when modifying a file.
    /// </summary>
    public enum ModifyActionOptionValue
    {
        /// <summary>
        /// Replace the old value with the new value.
        /// </summary>
        Replace,

        /// <summary>
        /// Append the new value to the old value.
        /// </summary>
        Append
    }
}
