using System;

namespace Microsoft.Sdc.Tasks.Xml
{
    /// <summary>
    /// Extended logging option for ModifyFile:
    ///     No:         no logging of matches (default)
    ///     Yes:        log matches
    ///     Masked:     log matches but hide the replacement value using '*' characters
    ///     Secure:     log matches but do not display replacement data, the replacement value is always displayed as 8 '*' characters
    /// </summary>
    public enum ShowMatchOptionValue
    {
        No,
        Yes,
        Masked,
        Secure
    }
}
